unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls;

const
  np = 2;
  ReAnz = 10;
type
   re1 = record
    re_ca : array[0..np] of double;
    re_cw : array[0..np] of double;
    re_cm : array[0..np] of double;
    re_alfa : array[0..np] of double;
    revorg : integer;{Re-Zahl}
    azca, azcw, azalpha, azcm : integer; {Anzahl der Zeilen}
  end;

  type     {Später speichern mit -> DateiV : file of re2}
   re2 = record
    realle : array[1..ReAnz] of re1;{10 maximal}
    profilname : string[50];
    herkunft : string[50];
    alpha0_p, cmnull_p : double;
    anzReZahl66 : integer;{hier tatsächliche Re - Anzahl speichern}
  end;                      

type
  
  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    procedure Speichern;
    procedure Laden;
    procedure DatenGenerieren;

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

var
  rewerte, rewerte1 : re2;
  
const
  root1 = 'test.dat';

procedure TForm1.Button1Click(Sender: TObject);
begin
  DatenGenerieren;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Speichern;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Laden;
end;

procedure TForm1.DatenGenerieren;
var
  i: Integer;
begin
  FillChar(rewerte, SizeOf(rewerte), 0);
  
  for i := 1 to rewerte.anzReZahl66 do
  begin
    rewerte.realle[i].re_ca[0] := 0.1 + i;
    rewerte.realle[i].re_ca[1] := 0.2 + i;
    rewerte.realle[i].re_cw[0] := -0.1 - i;
    rewerte.realle[i].re_cw[1] := -0.2 - i;
    rewerte.realle[i].re_cm[0] := 1000.1 + i;
    rewerte.realle[i].re_cm[1] := 1000.1 + i;
    rewerte.realle[i].re_alfa[0] := 0.01;
    rewerte.realle[i].re_alfa[1] := 0.02;
    rewerte.realle[i].revorg := 10;
    rewerte.realle[i].azca := 2;
    rewerte.realle[i].azcw := 2;
    rewerte.realle[i].azalpha := 2;
    rewerte.realle[i].azcm := 2;
  end;
  
  rewerte.ProfilName := 'Test';
  rewerte.Herkunft := 'von hier';
  rewerte.alpha0_p := 0.1234;
  rewerte.cmnull_p := 4.567;
  rewerte.anzReZahl66 := 2;
  
end;

procedure TForm1.speichern;
var
  DateiV: File;
begin
  assignFile(DateiV, root1);
  {$i-}
  rewrite(DateiV);
  if IOResult <> 0 then
  begin
   MessageDlg('Fehler bei Dateibehandlung! ',mtError,[mbok],0);
   exit;
  end;
  
  BlockWrite(DateiV, rewerte, SizeOf(rewerte)); {rewerte global aus prof1}
  if IOResult <> 0 then
  begin
   MessageDlg('Fehler bei Dateibehandlung! ',mtError,[mbok],0);
   exit;
  end;
  {$i+}
  
  closeFile(DateiV);
 end;{proz}

{Profil - Daten aus Record re2 b.z.w rewerte ***************************}
procedure TForm1.laden;
var
  DateiV: File;
begin
  assignFile(DateiV, root1);             {Pfad verbinden}
  {$i-}
  reset(DateiV, 1);                         {Datei öffnen}
  if IOResult <> 0 then
  begin
    MessageDlg('Fehler bei Dateibehandlung! ',mtError,[mbok],0);
    exit;
  end;
  
  FillChar(rewerte1, SizeOf(rewerte1), 0);
  Blockread(DateiV, rewerte1, SizeOf(rewerte1));
  if IOResult <> 0 then
  begin
    MessageDlg('Fehler bei Dateibehandlung! ',mtError,[mbok],0);
    exit;
  end;
  closeFile(DateiV);                    {Datei schließen}
  {$i+}
  
  if not CompareMem(@rewerte, @rewerte1, Sizeof(re2)) then
    MessageDlg('Gelesene Daten sind unterschiedlich.', mtError, [mbOK], 0)
  else
    MessageDlg('Übereinstimmung', mtInformation, [mbOK], 0);
end; {proz}

end.

